routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

use App\Event;
use Illuminate\Support\Facades\Auth;

Route::get('/', 'EventController@index')->name('index');

Auth::routes();

Route::get('/home', 'HomeController@index')->name('home');

Route::get('/administrators/panel', 'AdministratorController@panel');

Route::resources([
    'macrocategories' => 'MacrocategoryController',
    'categories' => 'CategoryController',
    'customers' => 'CustomerController',
    'organizers' => 'OrganizerController',
    'administrators' => 'AdministratorController',
    'events' => 'EventController',
    'tickets' => 'TicketController',
    'places' => 'PlaceController',
    'guests' => 'GuestController',
    'partecipates' => 'PartecipateController',
    'sponsors' => 'SponsorController',
    'sponsor_ranges' => 'SponsorRangeController',
    'funds' => 'FundController',
    'ticket_rate' => 'TicketRateController',
    'seat_types' => 'SeatTypeController',
    'seats' => 'SeatController',
    'statistics' => 'StatisticController',
]);

Route::get('/search', 'EventController@search');

Route::get('/cart/{id}/add', 'CartController@add_ticket')->name('add_to_cart');

Route::get('/cart/pay', 'CartController@pay')->name('cart.pay');

Route::resource('cart', 'CartController')->only('index', 'update', 'destroy');

Route::resource('orders', 'OrderController')->except([
    'edit', 'update', 'create', 'store'
]);

Route::get('/notifications', 'NotificationController@notifications');

Route::get('/favorites/{id}/remove', 'FavoriteController@remove')->name('remove_favorite');

Route::get('/favorites/{id}/add', 'FavoriteController@add')->name('add_favorite');

Route::resource('favorites', 'FavoriteController')->only(['store', 'destroy']);

Route::get('/myevents', 'MyEventsController@index');

Route::name('statistics.')->group(static function () {
    Route::get('category-age-average', 'StatisticController@categoryAgeAverage')->name('category-age-average');
    Route::get('category-ranking', 'StatisticController@categoryRanking')->name('category-ranking');
    Route::get('customer-spending-average', 'StatisticController@customerSpendingAverage')->name('customer-spending-average');
    Route::get('event-profit', 'StatisticController@eventProfit')->name('event-profit');
    Route::get('place-age-average', 'StatisticController@placeAgeAverage')->name('place-age-average');
    Route::get('place-profit', 'StatisticController@placeProfit')->name('place-profit');
    Route::get('sponsor-ranking', 'StatisticController@sponsorRanking')->name('sponsor-ranking');
    Route::get('ticket-sold-guest', 'StatisticController@ticketSoldGuest')->name('ticket-sold-guest');
});

app/Cart.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Support\Facades\Auth;

class Cart extends Model
{
    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = ['customer_id', 'ticket_id'];

    /**
     * The table associated with the model.
     *
     * @var string
     */
    protected $table = 'cart';

    public function user()
    {
        return $this->belongsTo(\App\User::class, "customer_id");
    }

    /**
     * Return tickets added to cart for the current user
     * @return array
     */
    public static function getCartItems()
    {
        $current_user = User::findOrFail(Auth::id());
        $userCart = Cart::where('customer_id', $current_user->id)->get();
        $tickets = [];

        if (isset($userCart)) {
            foreach ($userCart as $itemInCart) {
                $tickets[] = Ticket::where('id', $itemInCart->ticket->id)->first();
            }
        }

        return $tickets;
    }

    public function ticket()
    {
        return $this->belongsTo(\App\Ticket::class);
    }
}

app/Http/Controllers/CartController.php
<?php

namespace App\Http\Controllers;

use App\Cart;
use App\Event;
use App\Seat;
use App\SeatType;
use App\Ticket;
use App\TicketRate;
use App\User;
use App\Order;
use Carbon\Carbon;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Gate;

/**
 * Class CartController
 * @package App\Http\Controllers
 */
class CartController extends Controller
{
    public function __construct()
    {
        $this->middleware('auth');
    }

    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function index()
    {
        if (Gate::allows('isCustomer')) {
            $tickets = Cart::getCartItems();

            $total_price = null;
            if (!empty($tickets)) {
                $total_price = static::calc_total_price($tickets);
            }

            $ticket_rates = TicketRate::all();
            $seat_types = SeatType::all();

            return view('cart.index', compact('tickets', 'total_price', 'ticket_rates', 'seat_types'));
        }

        abort(404);
    }

    /**
     * Create a new Ticket for a given Event and add it to the Cart.
     * - checks if event has ended
     * - checks if there are more than N tickets for the same event in cart
     * - checks if there are still seats available for the event
     * - create ticket
     * - add ticket to cart
     * @param $event_id
     * @return \Illuminate\Contracts\Routing\ResponseFactory|\Illuminate\Http\Response
     */
    public function add_ticket($event_id)
    {
        if (Gate::allows('isCustomer')) {
            $current_user = User::findOrFail(Auth::id());
            $event = Event::findOrFail($event_id);

            if (strtotime($event->end_date) < time()) {
                return response('err_time', 400);
            }

            $tickets_count = DB::table('cart')
                ->join('tickets', 'cart.ticket_id', '=', 'tickets.id')
                ->join('events', 'tickets.event_id', '=', 'events.id')
                ->where('cart.customer_id', $current_user->id)
                ->where('events.id', $event->id)
                ->count();

            if ($tickets_count >= 5) {
                return response('err_max_tickets', 400);
            }

            if (isset($event->n_ticket_aval) && $event->n_ticket_aval <= 0) {
                return response('err_n_ticket', 400);
            }

            $event->n_ticket_aval--;
            $event->save();

            $newTicket = Ticket::create([
                'event_id' => $event_id,
            ]);

            Cart::create([
                'customer_id' => $current_user->id,
                'ticket_id' => $newTicket->id
            ]);

            return response('success', 200);
        }

        abort(404);
    }

    /**
     * Pay the order:
     * - checks if all tickets in cart have seat_type_id and ticket_rate_id set
     * - remove tickets from favorites
     * - create a new order
     * - link tickets to order
     * - remove tickets from cart
     * @param $id
     * @return \Illuminate\Contracts\Foundation\Application|\Illuminate\Http\RedirectResponse|\Illuminate\Routing\Redirector
     */
    public function pay()
    {
        $current_user = User::findOrFail(Auth::id());

        $itemsInCart = Cart::getCartItems();

        $userCart = Cart::where('ticket_id', $itemsInCart[0]->id)->first();

        if (!empty($itemsInCart) && Gate::allows('isCustomerOwner', $userCart->user)) {
            foreach ($itemsInCart as $itemInCart) {
                if (!isset($itemInCart->seat_type, $itemInCart->ticket_rate)) {
                    return redirect(route('cart.index'))
                        ->withErrors('Seleziona un posto e una tariffa per tutti i biglietti.');
                }
            }

            $order = Order::create([
                'customer_id' => $current_user->id
            ]);

            /**
             * TODO
             * a query is better?
             */
            foreach ($itemsInCart as $itemInCart) {
                foreach ($current_user->favorites as $favorite) {
                    if ($itemInCart->event->id === $favorite->event->id) {
                        $favorite->delete();
                    }
                }
                $itemInCart->order_id = $order->id;
                $itemInCart->save();
                Cart::where('ticket_id', $itemInCart->id)->first()->delete();
            }
            return redirect(route('orders.show', $order->id))
                    ->with('success', 'Hai appena effettuato l\'ordine numero '.$order->id.'.');
        }

        abort(404);
    }

    /**
     * Update tickets' in cart:
     * - checks if sent tickets are in cart
     * - checks if seat_type is set and is valid (seat->quantity - sold tickets for that quantity)
     * - checks if ticket_rate is set and is valid
     * - calculates and sets final price for ticket
     * - set ticket_rate to 0 (if available) if seat_type is 0
     * TODO COMPLETE
     * @param Request $request
     * @return \Illuminate\Contracts\Foundation\Application|\Illuminate\Http\RedirectResponse|\Illuminate\Routing\Redirector
     */
    public function update(Request $request, $ticket_id)
    {
        if (!Gate::allows('isCustomer')) {
            abort(404);
        }

        $current_user = User::findOrFail(Auth::id());

        if (Gate::allows('isCustomerOwner', $current_user)) {
            $ticket = Ticket::findOrFail($ticket_id);

            $cart_item = Cart::where('customer_id', $current_user->id)
                ->where('ticket_id', $ticket->id)
                ->first();

            if (!isset($cart_item)) {
                return redirect(route('cart.index'))->withErrors('Il biglietto non è presente nel tuo carrello.');
            }

            $validData = $request->validate([
                'seat_type_id' => 'required|exists:seat_types,id',
                'ticket_rate_id' => 'required|exists:ticket_rates,id'
            ]);

            $seat = Seat::where('seat_type_id', $request['seat_type_id'])
                        ->where('event_id', $ticket->event->id)
                        ->first();

            $tickets_sold_seat_type = Ticket::whereNotNull('order_id')
                                            ->where('event_id', $ticket->event->id)
                                            ->where('seat_type_id', $request['seat_type_id'])
                                            ->count();

            if ($seat->quantity > $tickets_sold_seat_type) {
                $ticket->seat_type_id = $validData['seat_type_id'];
            } else {
                return redirect(route('cart.index'))
                        ->withErrors('Non sono più disponibili biglietti per l\'evento '.$ticket->event->name .
                            ' con posto ' . SeatType::findOrFail($request['seat_type_id'])->name);
            }

            $ticket->ticket_rate_id = $validData['ticket_rate_id'];

            $ticket_rate_zero = TicketRate::where('amount', 0.0)->first();
            if ((double)$seat->unit_price === 0.0 &&
                isset($ticket_rate_zero->amount) &&
                (double)$ticket_rate_zero->amount === 0.0) {
                $ticket->ticket_rate_id = $ticket_rate_zero->id;
            }

            $ticket->final_price = $seat->unit_price * (1 - TicketRate::findOrFail($ticket->ticket_rate_id)->amount);
            $ticket->save();

            return redirect(route('cart.index'));
        }
    }

    /**
     * Remove a ticket from cart, aka
     * - delete cart entry
     * - delete ticket entry
     * - increment n_ticket_aval
     * @param Cart $cart
     */
    public function destroy($ticket_id)
    {
        $cart = Cart::where('ticket_id', $ticket_id)->first();

        if (Gate::allows('isCustomerOwner', $cart->user)) {
            $event = $cart->ticket->event;
            ++$event->n_ticket_aval;
            $event->save();
            $ticket = $cart->ticket;
            $cart->delete();
            $ticket->delete();
            return redirect(route('cart.index'));
        }

        abort(404);
    }

    /**
     * @param $tickets
     * @return float|int
     */
    public static function calc_total_price($tickets)
    {
        $total_price = 0;
        foreach ($tickets as $ticket) {
            if (isset($ticket->final_price)) {
                $total_price += $ticket->final_price;
            }
        }
        return $total_price;
    }
}

resources/views/cart/index.blade.php
@extends('layouts.app')

@section('content')
@can('isCustomer', auth()->user())
    <h1>Carrello</h1>
    @if ($errors->any())
        <div class="card-panel red lighten-1">
            <ul>
                @foreach ($errors->all() as $error)
                    <li>{{ $error }}</li>
                @endforeach
            </ul>
        </div><br />
    @endif
    @if(!empty($tickets))
        <div class="row">
            @foreach($tickets as $ticket)
                @include('layouts.event-card.cart')
            @endforeach
        </div>
        <h5 id="price" class="right">Prezzo totale: {{ number_format($total_price, 2) }} €</h5>

        <div class="fixed-action-btn">
            <a href="#pay-modal" class="btn-floating btn-large modal-trigger fab-padding green">
                <i class="large material-icons">attach_money</i>
            </a>
        </div>

        <!--
        <div class="fixed-action-btn">
            <a class="btn-floating btn-large">
                <i class="large material-icons">shopping_cart</i>
            </a>
            <ul>
                <li>
                    <a href="#cart-delete-modal" onclick="delete_cart($order->id)" class="btn-floating fab-padding modal-trigger red">
                        <i class="material-icons">delete</i>
                    </a>
                    <a href="#" class="btn-floating mobile-fab-tip">Svuota il carrello</a>
                </li>
                <li>
                    <a class="btn-floating blue fab-padding" onclick="save_cart()" ><i class="material-icons">save</i></a>
                    <a href="#" class="btn-floating mobile-fab-tip">Salva il carrello</a>
                </li>
                <li>
                    <a href="#pay-modal" onclick="pay($order->id)" class="btn-floating fab-padding modal-trigger green">
                        <i class="material-icons">attach_money</i>
                    </a>
                    <a href="#" class="btn-floating mobile-fab-tip">Conferma ordine</a>
                </li>
            </ul>
        </div>
        -->
        <div id="ticket-delete-modal" class="modal">
            <form id="ticket-delete-form" action="" method="post">
                <div class="modal-content">
                    @csrf
                    @method('DELETE')
                    <h4>Conferma</h4>
                    <p>Sei sicuro di voler rimuovere il biglietto dal carrello?</p>
                </div>
                <div class="modal-footer">
                    <a href="#!" class="btn btn-flat modal-close red">No</a>
                    <button type="submit" name="" class="btn btn-flat green" onclick="ticket_delete_submit()">Si</button>
                </div>
            </form>
        </div>

        <div id="pay-modal" class="modal">
            <form id="pay-form" action="{{ route("cart.pay") }}" method="get">
                <div class="modal-content">
                    <h4>Conferma</h4>
                    <p>Sei sicuro di voler procedere con l'ordine?</p>
                </div>
                <div class="modal-footer">
                    <a href="#!" class="btn btn-flat modal-close red">No</a>
                    <button type="submit" name="" class="btn btn-flat green" onclick="pay_submit()">Si</button>
                </div>
            </form>
        </div>

        <div id="cart-delete-modal" class="modal">
            <form id="cart-delete-form" action="" method="post">
                <div class="modal-content">
                    @csrf
                    @method('DELETE')
                    <h4>Conferma</h4>
                    <p>Sei sicuro di voler svuotare il carrello?</p>
                </div>
                <div class="modal-footer">
                    <a href="#!" class="btn btn-flat modal-close red">No</a>
                    <button type="submit" name="" class="btn btn-flat green" onclick="cart_delete_submit()">Si</button>
                </div>
            </form>
        </div>

        <script>
            document.addEventListener('DOMContentLoaded', function() {
                let elems = document.querySelectorAll('.fixed-action-btn');
                let instances = M.FloatingActionButton.init(elems);
            });

            /*
            function save_cart() {
                let ticket_nodes = document.getElementsByName("n_ticket");
                let ticket_rates = document.getElementsByName("ticket_rate_id");
                let ticket_array = Array.from(ticket_nodes);
                let ticket_rates_array = Array.from(ticket_rates);
                let tickets = [];
                for (let i = 0; i < ticket_array.length; i++) {
                    tickets[i] = {id:ticket_array[i].id, quantity:ticket_array[i].value, ticket_rate:ticket_rates_array[i].options[ticket_rates_array[i].selectedIndex].value};
                }
                let tickets_json = JSON.stringify(tickets);
                let xmlHttp = new XMLHttpRequest();
                xmlHttp.onreadystatechange = function() {
                    if (xmlHttp.readyState == 4) {
                        if (xmlHttp.status === 404) {
                            M.toast({html: "Si sono verificati degli errori.", classes: 'red'});
                            window.location.href = window.location.href;
                        } else {
                            console.log(xmlHttp.responseText);
                            let response = JSON.parse(xmlHttp.responseText);
                            if (typeof response['error'] !== 'undefined') {
                                M.toast({html: response['error'], classes: 'red'});
                                if (response['old'] !== null) {
                                    for (let i = 0; i < response['old'].length; i++) {
                                        ticket_nodes[i].value = response['old'][i];
                                    }
                                }
                            } else {
                                M.toast({html: "Carrello salvato.", classes: 'green'});
                                let price = document.getElementById("price");
                                price.innerHTML = response['price'].toFixed(2) + ' €';
                            }
                        }
                    }
                };
                xmlHttp.open("POST", "/cart/update", true);
                xmlHttp.setRequestHeader("x-csrf-token", "{{csrf_token()}}");
                xmlHttp.send(tickets_json);
            }
            */

            function delete_ticket(id)
            {
                let url = '{{ route("cart.destroy", ":id") }}';
                url = url.replace(':id', id);
                $("#ticket-delete-form").attr('action', url);
            }

            function ticket_delete_submit()
            {
                $("#ticket-delete-form").submit();
            }

            function delete_cart(id)
            {
                let url = '{{ route("orders.destroy", ":id") }}';
                url = url.replace(':id', id);
                $("#cart-delete-form").attr('action', url);
            }

            function cart_delete_submit()
            {
                $("#cart-delete-form").submit();
            }

            function pay_submit()
            {
                $("#pay-form").submit();
            }

            $(document).ready(function() {
                function toggleUpdateButton(item) {
                    let to = !(item.closest('.card').find('select[name=\"ticket_rate_id\"]').prop('selectedIndex')
                                && item.closest('.card').find('select[name=\"seat_type_id\"]').prop('selectedIndex'));
                    item.closest(".card").find('.ticket-update').toggleClass('disabled', to);
                }

                $( "select[name=\"ticket_rate_id\"]" ).change(function() {
                    toggleUpdateButton($(this));
                });

                $( "select[name=\"seat_type_id\"]" ).change(function() {
                    toggleUpdateButton($(this));
                });
            });
        </script>
    @else
        <h5 class="center">Non ci sono biglietti nel tuo carrello.</h5>
    @endisset
@endcan
@endsection